// index-builder.js - code to build XUL trees (and HTML items).
// Needs refactoring.
// $Header: /cvs/archangel/src/archangel/content/index-builder.js,v 1.2 2003/01/30 20:33:27 marnanel Exp $
//
// Copyright (c) 2002 Thomas Thurman
// thomas@thurman.org.uk
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have be able to view the GNU General Public License at 
// http://www.gnu.org/copyleft/gpl.html ; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

////////////////////////////////////////////////////////////////
//
// Code to modify the index tree.

function addToIndex(celltexts) {

	function cell(text) {
		var c = document.createElement('treecell');
		c.setAttribute('label', text);
		return c;
	}

	var holder = document.getElementById('groggs-items');
	var item = document.createElement('treeitem');
	var row = document.createElement('treerow');

	for (var i=0; i<celltexts.length; i++)
		row.appendChild(cell(celltexts[i]));

	item.appendChild(row);

	holder.appendChild(item);
}

////////////////////////////////////////////////////////////////
//
// Code to modify the HTML item display

function clearItemLines() {
	var holder = document.getElementById('item-display');
	if (holder) {
		while (holder.hasChildNodes()) 
			holder.removeChild(holder.lastChild);
	} else
		throw 'item-display element not found!';
}

html = "http://www.w3.org/1999/xhtml";
http_url = /(http:\/\/[A-Za-z0-9_+~#\/?%.,&-]*)/;

function addItemLine(line) {
	var holder = document.getElementById('item-display');

	var where = 0;

	do {

		where = line.search(http_url);

		if (where==-1) {
			holder.appendChild(document.createTextNode(line));
		} else {
			var target_url = RegExp.$1;
			var link = document.createElementNS(html, 'html:a');

			holder.appendChild(document.createTextNode(line.substring(0, where)));

			link.setAttribute('href', target_url);
			link.setAttribute('target', '_blank'); // for everyone's sanity
			link.appendChild(document.createTextNode(target_url));
			holder.appendChild(link);

			line = line.substring(where+target_url.length);
		}

	} while (where!=-1);

	holder.appendChild(document.createElementNS(html, 'html:br'));
}

function addAttributionBlock(details) {
	var holder = document.getElementById('item-display');
	var div = document.createElementNS(html, 'html:div');

	div.setAttribute('class', 'attribution');

	for (var i=0; i<details.length; i++) {
		div.appendChild(document.createTextNode(details[i]));
		div.appendChild(document.createElementNS(html, 'html:br'));
	}

	holder.appendChild(div);
}

////////////////////////////////////////////////////////////////
//
// Code to modify the status bar at the foot of the page
// (not used at present)

function setStatus(s) {
	document.getElementById('status').setAttribute('value',s);
}

function stripyMeter() {
	var meter = document.getElementById('progress');
	meter.setAttribute('mode', 'undetermined');
}

function percentage(n) {
	var meter = document.getElementById('progress');
	meter.setAttribute('mode', 'determined');
	meter.setAttribute('value', Math.round(n)+'%');
}

function calmMeter() {
	percentage(0);
	setStatus('Ready');
}

// eof index-builder.js


